/*#
# **************************************************************
# *                  SIMUSOL PROYECT                           *
# *                                                            *
# *         Table extension for:                               *
# *         C++ Mathematical Expression Toolkit Library        *
# *         which is located in:                               *
# * URL: http://www.partow.net/programming/exprtk/index.html   *
# *                                                            *
# *   The extension was developed by                           *
# *   Diego.Saravia@gmail.com, 2016                            *
# *   and could be used in the same terms of the toolkit       *
# *   or every free license with copyleft needed.              *
# *   http://www.simusol.org                                   *
# **************************************************************
# This file is part of Table.
#
#    Table is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Table is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Table.  If not, see <http://www.gnu.org/licenses/>.*/
struct table{
   char **encabezados;
   unsigned int numeroslintot; //available encabezado , no es necesario aqui, puede estar solo en el programa pero mejor aca
   unsigned int znumeroslin; //occupy encabezado

   double *datos;
   int *lineadatos;
  unsigned int numdatos;     //occupy
  unsigned int datostam;     //available

  
  //   unsigned int numeroslinok; // no se, parece numero de encabezados

   const char *file;   // redundante


   struct view  **pointers;
   unsigned int numviews;  //occupy      // todo lo de malloc a unsigned, elimino error
  unsigned int numviewsavailable; //available

  
   unsigned int totallineas;  //lineas      occupy 
   unsigned int lineasavailable;  //lineas  available
   unsigned int * columnasporlinea; //numeroslin encabezado en 0, cantidad de columans en cada linea  ,estos ultimos dos no son estrictamente necesarios
   unsigned int * terminalinea; // el ultimo dato de la linea, seria la suma de las columnas
  
};



struct dynlist{
  const char **names;
  unsigned int occupy; //cant usados de la memoria
  unsigned int available; //tam;
  struct table **dpointers;
};

struct view{ //no se pueden usar las columnas independientemente porque
             // hay vacios en las y entonces x cambia para cada y
 int *meta;
 double *cx;
 double *cy1;
 double *cy2;
 double *cy3;
 double *dy2;
 int hdy2; 
 unsigned int size;
 unsigned int nx;
 unsigned int ny; 
 int table; //redundante
};




// initialize data structure, get pointer to it
struct dynlist * get_ini_tablelist(void);
int load_table(struct table *); //use bison yacc
int derivative2 (struct view *);
